// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package calculator

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CalculatorClient is the client API for Calculator service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CalculatorClient interface {
	Increment(ctx context.Context, in *Number, opts ...grpc.CallOption) (*Number, error)
	Decrement(ctx context.Context, in *Number, opts ...grpc.CallOption) (*Number, error)
	CountFromTo(ctx context.Context, in *Tuple, opts ...grpc.CallOption) (Calculator_CountFromToClient, error)
	SumSeveral(ctx context.Context, opts ...grpc.CallOption) (Calculator_SumSeveralClient, error)
	LiveSum(ctx context.Context, opts ...grpc.CallOption) (Calculator_LiveSumClient, error)
}

type calculatorClient struct {
	cc grpc.ClientConnInterface
}

func NewCalculatorClient(cc grpc.ClientConnInterface) CalculatorClient {
	return &calculatorClient{cc}
}

func (c *calculatorClient) Increment(ctx context.Context, in *Number, opts ...grpc.CallOption) (*Number, error) {
	out := new(Number)
	err := c.cc.Invoke(ctx, "/calculator.Calculator/Increment", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *calculatorClient) Decrement(ctx context.Context, in *Number, opts ...grpc.CallOption) (*Number, error) {
	out := new(Number)
	err := c.cc.Invoke(ctx, "/calculator.Calculator/Decrement", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *calculatorClient) CountFromTo(ctx context.Context, in *Tuple, opts ...grpc.CallOption) (Calculator_CountFromToClient, error) {
	stream, err := c.cc.NewStream(ctx, &Calculator_ServiceDesc.Streams[0], "/calculator.Calculator/CountFromTo", opts...)
	if err != nil {
		return nil, err
	}
	x := &calculatorCountFromToClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Calculator_CountFromToClient interface {
	Recv() (*Number, error)
	grpc.ClientStream
}

type calculatorCountFromToClient struct {
	grpc.ClientStream
}

func (x *calculatorCountFromToClient) Recv() (*Number, error) {
	m := new(Number)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *calculatorClient) SumSeveral(ctx context.Context, opts ...grpc.CallOption) (Calculator_SumSeveralClient, error) {
	stream, err := c.cc.NewStream(ctx, &Calculator_ServiceDesc.Streams[1], "/calculator.Calculator/SumSeveral", opts...)
	if err != nil {
		return nil, err
	}
	x := &calculatorSumSeveralClient{stream}
	return x, nil
}

type Calculator_SumSeveralClient interface {
	Send(*Number) error
	CloseAndRecv() (*Number, error)
	grpc.ClientStream
}

type calculatorSumSeveralClient struct {
	grpc.ClientStream
}

func (x *calculatorSumSeveralClient) Send(m *Number) error {
	return x.ClientStream.SendMsg(m)
}

func (x *calculatorSumSeveralClient) CloseAndRecv() (*Number, error) {
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	m := new(Number)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *calculatorClient) LiveSum(ctx context.Context, opts ...grpc.CallOption) (Calculator_LiveSumClient, error) {
	stream, err := c.cc.NewStream(ctx, &Calculator_ServiceDesc.Streams[2], "/calculator.Calculator/LiveSum", opts...)
	if err != nil {
		return nil, err
	}
	x := &calculatorLiveSumClient{stream}
	return x, nil
}

type Calculator_LiveSumClient interface {
	Send(*Number) error
	Recv() (*Number, error)
	grpc.ClientStream
}

type calculatorLiveSumClient struct {
	grpc.ClientStream
}

func (x *calculatorLiveSumClient) Send(m *Number) error {
	return x.ClientStream.SendMsg(m)
}

func (x *calculatorLiveSumClient) Recv() (*Number, error) {
	m := new(Number)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// CalculatorServer is the server API for Calculator service.
// All implementations must embed UnimplementedCalculatorServer
// for forward compatibility
type CalculatorServer interface {
	Increment(context.Context, *Number) (*Number, error)
	Decrement(context.Context, *Number) (*Number, error)
	CountFromTo(*Tuple, Calculator_CountFromToServer) error
	SumSeveral(Calculator_SumSeveralServer) error
	LiveSum(Calculator_LiveSumServer) error
	mustEmbedUnimplementedCalculatorServer()
}

// UnimplementedCalculatorServer must be embedded to have forward compatible implementations.
type UnimplementedCalculatorServer struct {
}

func (UnimplementedCalculatorServer) Increment(context.Context, *Number) (*Number, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Increment not implemented")
}
func (UnimplementedCalculatorServer) Decrement(context.Context, *Number) (*Number, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Decrement not implemented")
}
func (UnimplementedCalculatorServer) CountFromTo(*Tuple, Calculator_CountFromToServer) error {
	return status.Errorf(codes.Unimplemented, "method CountFromTo not implemented")
}
func (UnimplementedCalculatorServer) SumSeveral(Calculator_SumSeveralServer) error {
	return status.Errorf(codes.Unimplemented, "method SumSeveral not implemented")
}
func (UnimplementedCalculatorServer) LiveSum(Calculator_LiveSumServer) error {
	return status.Errorf(codes.Unimplemented, "method LiveSum not implemented")
}
func (UnimplementedCalculatorServer) mustEmbedUnimplementedCalculatorServer() {}

// UnsafeCalculatorServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CalculatorServer will
// result in compilation errors.
type UnsafeCalculatorServer interface {
	mustEmbedUnimplementedCalculatorServer()
}

func RegisterCalculatorServer(s grpc.ServiceRegistrar, srv CalculatorServer) {
	s.RegisterService(&Calculator_ServiceDesc, srv)
}

func _Calculator_Increment_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Number)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CalculatorServer).Increment(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/calculator.Calculator/Increment",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CalculatorServer).Increment(ctx, req.(*Number))
	}
	return interceptor(ctx, in, info, handler)
}

func _Calculator_Decrement_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Number)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CalculatorServer).Decrement(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/calculator.Calculator/Decrement",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CalculatorServer).Decrement(ctx, req.(*Number))
	}
	return interceptor(ctx, in, info, handler)
}

func _Calculator_CountFromTo_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(Tuple)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CalculatorServer).CountFromTo(m, &calculatorCountFromToServer{stream})
}

type Calculator_CountFromToServer interface {
	Send(*Number) error
	grpc.ServerStream
}

type calculatorCountFromToServer struct {
	grpc.ServerStream
}

func (x *calculatorCountFromToServer) Send(m *Number) error {
	return x.ServerStream.SendMsg(m)
}

func _Calculator_SumSeveral_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(CalculatorServer).SumSeveral(&calculatorSumSeveralServer{stream})
}

type Calculator_SumSeveralServer interface {
	SendAndClose(*Number) error
	Recv() (*Number, error)
	grpc.ServerStream
}

type calculatorSumSeveralServer struct {
	grpc.ServerStream
}

func (x *calculatorSumSeveralServer) SendAndClose(m *Number) error {
	return x.ServerStream.SendMsg(m)
}

func (x *calculatorSumSeveralServer) Recv() (*Number, error) {
	m := new(Number)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func _Calculator_LiveSum_Handler(srv interface{}, stream grpc.ServerStream) error {
	return srv.(CalculatorServer).LiveSum(&calculatorLiveSumServer{stream})
}

type Calculator_LiveSumServer interface {
	Send(*Number) error
	Recv() (*Number, error)
	grpc.ServerStream
}

type calculatorLiveSumServer struct {
	grpc.ServerStream
}

func (x *calculatorLiveSumServer) Send(m *Number) error {
	return x.ServerStream.SendMsg(m)
}

func (x *calculatorLiveSumServer) Recv() (*Number, error) {
	m := new(Number)
	if err := x.ServerStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// Calculator_ServiceDesc is the grpc.ServiceDesc for Calculator service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Calculator_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "calculator.Calculator",
	HandlerType: (*CalculatorServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Increment",
			Handler:    _Calculator_Increment_Handler,
		},
		{
			MethodName: "Decrement",
			Handler:    _Calculator_Decrement_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "CountFromTo",
			Handler:       _Calculator_CountFromTo_Handler,
			ServerStreams: true,
		},
		{
			StreamName:    "SumSeveral",
			Handler:       _Calculator_SumSeveral_Handler,
			ClientStreams: true,
		},
		{
			StreamName:    "LiveSum",
			Handler:       _Calculator_LiveSum_Handler,
			ServerStreams: true,
			ClientStreams: true,
		},
	},
	Metadata: "calculator.proto",
}
